// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

/*
  Node is based to some extent on SVG syntax
  Kind refers to the current and previous points
  if kind is M, the node is the head
  All points are Absolute 
*/
class Node
{
  char kind;
  float x1;
  float y1;
  
  float cx1;
  float cy1;
  float cx2;
  float cy2;
  
  Node next;
  
  
  Node()
  {
    x1=0;
    y1=0;
    kind='L'; //absolute line
    next=null;
  }
  
  Node(char newKind, float newX, float newY, Node newNext)
  {
    x1=newX;
    y1=newY;
    kind=newKind;
    next=newNext;
    cx1 = cy1 = cx2 = cy2 = 0;
  }

/* constructor for curves! :)
*/
  Node(char newKind, float newCX1, float newCY1, float newCX2, float newCY2, float newX, float newY, Node newNext){
    x1=newX;
    y1=newY;
    kind=newKind;
    next=newNext;
    cx1=newCX1;
    cy1=newCY1;
    cx2=newCX2;
    cy2=newCY2;
  }

  Node getNext(){
    return next;
  }
  
   void setNext(Node newNext){
    next=newNext;
  }
  
  float getX(){
    return x1;
  }
  
  float getY(){
    return y1;
  }
  
  char getKind(){
    return kind;
  }
  
}
