// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

import java.io.File; // For file saving/opening dialog boxes.
import processing.serial.*; // For serial communications
/* video
import processing.video.*;
*/

String g_path; 
ArrayList g_shapeList = new ArrayList();
int[] g_servoAngles = { 52, 143, 30, 131, 20, 160 }; // Shoulder small, Shoulder large, Elbow small, Elbow large, Wrist Min, Wrist Max)
int[] g_servoPulses = { 1888, 1888, 1430, 1430, 600, 1430 };
//int[] g_servoPulses = { 908, 2513, 611, 2076, 600, 2300 };
//OLD   int[] g_servoPulses = { 608, 2013, 611, 2076, 600, 2300 };
Arm arm=new Arm();


String mode="standby";
char shapeType='L';

//SerialDev mySerialDev=new SerialDev(); //our serial device

Node curNode=null;
Node curHead=null;

Traverse theTraverse;

String message;
final boolean USE_CROSS_HAIR = true;
final boolean USE_ARROW = false;
final int mainButtonCount = 12;
final int imageButtonCount = 16;
final int buttonCount = 18;
Button[] button = new Button[buttonCount];
final int BUTTON_DRAW = 0;
final int BUTTON_DRAWLINE = 1;
final int BUTTON_DRAWCURVE = 2;
final int BUTTON_UNDO = 3;
final int BUTTON_CLEAR = 4;
final int BUTTON_OPEN = 5;
final int BUTTON_SAVE = 6;
final int BUTTON_CALIBRATE = 7;
final int BUTTON_SEND = 8;
final int BUTTON_DRAWCIRCLE = 9;
final int BUTTON_HELP = 10;
final int BUTTON_STOP = 11;
final int BUTTON_IMPORT = 12;
final int BUTTON_LOAD = 13;
final int BUTTON_CANCEL = 14;
final int BUTTON_DEFAULTS = 15;
final int BUTTON_CALIBRATENEXT = 16;
final int BUTTON_CALIBRATECANCEL = 17;
final int scrollBarCount = 7;
ScrollBar[] scrollBar = new ScrollBar[scrollBarCount];
final int SBAR_LT = 0;
final int SBAR_HT = 1;
final int SBAR_KR = 2;
final int SBAR_KW = 3;
final int SBAR_SERVO1 = 4;
final int SBAR_SERVO2 = 5;
final int SBAR_SERVO3 = 6;

final int paperOffsetX = 80;
final int paperOffsetY = 183;
final int paperSizeX = 354;
final int paperSizeY = 276;
final int startOffsetX = 354;
final int startOffsetY = 104;
//final int armWristXMin = 

HashMap allMessages=new HashMap();
HashMap allButtons=new HashMap();

//import processing.opengl.*;

boolean sketchFullScreen()
{
  return false;
  //return true;
}

boolean isWindows()
{ 
  String OS = System.getProperty("os.name").toLowerCase();
  return (OS.indexOf("win") >= 0);
}
 
boolean isMac()
{
  String OS = System.getProperty("os.name").toLowerCase();
  return (OS.indexOf("mac") >= 0);
}

PImage logo;
PImage TERlogo;

Serial launchPad = null;
String launchPadPort = "";
String lastCommandSent = "";
int retrySerial = 1;

void loadPulses()
{
  String pulses[] = loadStrings("servocalibration.txt");
  if (pulses != null && pulses.length == 6)
  {
    //println("AA");
    for (int i=0; i < 6; i++)
      g_servoPulses[i] = int(pulses[i]);   
  }

  if (launchPad != null) {
    launchPad.write("r");
    delay(100);
  }
}

void savePulses()
{
  String pulses[] = new String[6];

  for (int i=0; i < 6; i++)
    pulses[i] = str(g_servoPulses[i]);

  if (launchPad != null) {
    launchPad.write("w");
    launchPad.write(pulses[1]);
  }
//  saveStrings("servocalibration.txt", pulses);

}

void setup(){
  loadPulses();
  //size(800,600);
  //size(displayWidth, displayHeight);
  size(800, 600);
  button[BUTTON_DRAW]      = new Button("Draw",       width - 200, 80, 90, 50, USE_CROSS_HAIR);
  button[BUTTON_DRAWLINE]  = new Button("Draw Line",  width - 100, 80, 90, 50, USE_CROSS_HAIR);
  button[BUTTON_DRAWCURVE] = new Button("Draw Curve", width - 200, 140, 90, 50, USE_CROSS_HAIR);
  button[BUTTON_DRAWCIRCLE] = new Button("Draw Circle", width - 100, 140, 90, 50, USE_CROSS_HAIR);

  button[BUTTON_UNDO]      = new Button("Undo",       width - 200, 220, 90, 50, USE_CROSS_HAIR);
  button[BUTTON_CLEAR]     = new Button("Clear",      width - 100, 220, 90, 50, USE_ARROW);

  button[BUTTON_OPEN]      = new Button("Open",       width - 200, 300, 90, 50, USE_ARROW);
  button[BUTTON_SAVE]      = new Button("Save",       width - 100, 300, 90, 50, USE_ARROW);
  button[BUTTON_SEND]      = new Button("Transmit",   width - 200, 360, 90, 50, USE_ARROW);
  button[BUTTON_STOP]      = new Button("Stop",       width - 100, 360, 90, 50, USE_ARROW);

  button[BUTTON_HELP]      = new Button("Help",       width - 200, 440, 90, 50, USE_ARROW);
  button[BUTTON_CALIBRATE] = new Button("Calibrate",  width - 100, 440, 90, 50, USE_ARROW);
  button[BUTTON_CALIBRATENEXT] = new Button("Next",  width - 200, 440, 90, 50, USE_ARROW);
  button[BUTTON_CALIBRATECANCEL] = new Button("Cancel",  width - 100, 440, 90, 50, USE_ARROW);

  scrollBar[SBAR_LT] = new ScrollBar("Low threshold", 75, 420, 140, 10, 0.0, 20.0, lowThreshold, 1);
  scrollBar[SBAR_HT] = new ScrollBar("High threshold", 240, 420, 140, 10, 0.0, 20.0, highThreshold, 1);
  scrollBar[SBAR_KR] = new ScrollBar("Gaussian Radius", 405, 420, 140, 10, 0.1, 4, gaussianKernelRadius, 1);
  scrollBar[SBAR_KW] = new ScrollBar("Gaussian Width", 570, 420, 140, 10, 2, 64, gaussianKernelWidth, 0);
  button[BUTTON_IMPORT] = new Button("Import",  75, 475, 90, 50, USE_ARROW);
  button[BUTTON_LOAD] = new Button("Load file",  175, 475, 90, 50, USE_ARROW);
  button[BUTTON_CANCEL] = new Button("Cancel",  625, 475, 90, 50, USE_ARROW);
  button[BUTTON_DEFAULTS] = new Button("Defaults",  375, 475, 90, 50, USE_ARROW);

  scrollBar[SBAR_SERVO1] = new ScrollBar("Shoulder Servo", 20, 520, 520, 10, 600, 2400, 1888, 0);
  scrollBar[SBAR_SERVO2] = new ScrollBar("Elbow Servo", 20, 555, 520, 10, 600, 2400, 1888, 0);
  scrollBar[SBAR_SERVO3] = new ScrollBar("Wrist Servo", 600, 520, 200, 10, 600, 2400, 1888, 0);
  
  g_path = sketchPath("mac/");

  logo = loadImage(g_path + "PicassoBot.png");
  TERlogo = loadImage(g_path + "TERlogo.png");
  if (logo == null || TERlogo == null) {
    if (isMac())
      g_path = "PicassoBotSimulator.app/Contents/Resources/";
    else if (isWindows())
      g_path = "lib/";
    logo = loadImage(g_path + "PicassoBot.png");
    TERlogo = loadImage(g_path + "TERlogo.png");
  }

      // The following should set the title bar icon, but does not work right now.    
      //ImageIcon img = new ImageIcon("lib/sketch.png");
      //frame.setIconImage(img.getImage()); 
//Process tr = Runtime.getRuntime().exec( new String[]{ "cat" } );
  
  ///For text bar///
/*
  PFont font;
  font = loadFont("LucidaGrande-12.vlw"); 
  textFont(font);
*/
  createMessages();
  message=(String)allMessages.get("standby");
  
  frameRate(30);

int c;
  //String t = Serial.list()[1];
  //print(t);
  //for (c = 0; c < Serial.list().length; c++)
    //print(Serial.list()[c] + "\n");
    //connectSerial();
//  launchPad = new Serial(this, t, 9600);
    
  //launchPad.write("hello");
  //noLoop();
}



void serialEvent(Serial port)
{
  while (launchPad != null && port.available() > 0)
  {
    int b = port.read();
    print("" + char(b));
  }
}


void createMessages(){
  allMessages.put("standby", "");
  allMessages.put("selectShape","");
  allMessages.put("traverse", "Transmitting data to PicassoBot!");
  allMessages.put("calibrate", "CALIBRATING: Move servo sliders have pen lifted and positioned as shown.");
  allMessages.put("drawL", "Click to begin a line, click again to end the line.");
  allMessages.put("drawF", "Click to draw objects to send to PicassoBot.");  
  allMessages.put("drawC", "Click to add starting point, click again to add curve control line 1, \nclick again for control line 2, click again to set ending point.");
  allMessages.put("drawE", "Click to begin corner of ellipse region, click again for opposite corner.");

/*
  allMessages.put("standby", "'d'=draw, 'o'=open, 's'=save, 't'=trace, DEL to clear, 'x' to toggle sending, and 'q'=quit");
  allMessages.put("selectShape","'l'=line, 'f'=free draw, 'c'=curve, 'q'=quit, and '/'= return to standby");
  allMessages.put("traverse", "TRAVERSING!");
  allMessages.put("calibrate", "CALIBRATING!");
  allMessages.put("drawL", "click to add points to a line sequence.  'n'=new line sequence, 'q'=quit, and '/'= standby");
  allMessages.put("drawF", "to draw click and drag.  'q'=quit and '/'=standby");  
  allMessages.put("drawC", "click to add controls and then the ending point, 'n'=new curve sequence,'q'=quit, and '/'=standby");
  allMessages.put("drawE", "CIRCLES RULE!!!!");
*/
}
