// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

/* parses SVGs
 */
void parseSVG(String myFile){

  println(myFile);

  String[] commList=new String[0];//array of commands (charachters followed by tab-separated numbers)
  String curComm=""; //the surrent command, the one we're working on
  String[] numList=new String[0]; //the array of numbers (as strings) that will be the parameters for the current command
  String curNum=""; //the current number, the one we're working on

  String theString=""; //the SVG file, as a string
  String[] stringList=new String[0]; //an array of blocks of path data
  String myString=""; //the current block of SVG path data


  theString=new String(loadBytes(myFile)); //reads the file

    stringList=split(theString," d=\"");  //finds path data

  for(int s=1;s<stringList.length;s++){ //loops through bloack of data
    myString=stringList[s];
    commList=new String[0];
    curComm="";
    curNum="";
    for(int i=0;i<myString.length();i++){ //loops through the charachters of each block

      if (myString.charAt(i)>='A'&&myString.charAt(i)<='z'){

        if(curComm!=""){
          if(curNum!=""){
            numList=append(numList,curNum);
            curNum="";
          }

          if(numList.length>0)
            commList=append(commList,curComm+"\t"+join(numList,"\t"));
          else
            commList=append(commList,curComm);
        }
        curComm=str(char(myString.charAt(i)));
        numList=new String[0];

        //  println(curComm);
      }
      else if(myString.charAt(i)>='0' && myString.charAt(i)<='9'){
        curNum=curNum+str(char(myString.charAt(i)));
      }
      else if(myString.charAt(i)=='-'){
        if(curNum!="")
          numList=append(numList,curNum);
        curNum="-";
      }
      else if(myString.charAt(i)==',' || myString.charAt(i)==' '){
        if(curNum != ""){
          numList=append(numList,curNum);
          curNum="";
        }
      }//end of if ',' or ' '
      else if(myString.charAt(i)=='.'){
        if(curNum.indexOf(".")!=-1){
          numList=append(numList,curNum);
          curNum="";
        }
        curNum=curNum+".";
      }//end of if a period
      else if(myString.charAt(i)=='"'){
        if(curNum!="")
          numList=append(numList,curNum);

        if(commList.length>0){
          if(numList.length>0)
            commList=append(commList,curComm+"\t"+join(numList,"\t"));
          else
            commList=append(commList,curComm);
        }//end of if there are commands
        break;
      }//end of if we're done with the block
    }//end of for loop through characters

    addShapes(commList);
  }//end of for to loop through blocks
}//end of method


void addShapes(String[] commList){

  String[] comm=new String[0];
  float cpx=0;//current point
  float cpy=0;
  float cpx1=0;//current control point
  float cpy1=0;
  float ipx=0;//initial point--needed for Z
  float ipy=0;

  for(int i=0;i<commList.length;i++){
    comm=split(commList[i],"\t");

    switch(comm[0].charAt(0)){
    case 'M'://move to
      if(curHead==null){
        curHead=new Node('M', float(comm[1]), float(comm[2]), null);
        curNode=curHead;
      }      
      else
        curNode.setNext(new Node('M', float(comm[1]), float(comm[2]), null));
      cpx=float(comm[1]);
      cpy=float(comm[2]);
      ipx=cpx;
      ipy=cpy;
      break;
    case 'L'://line to
      curNode.setNext(new Node('L', float(comm[1]), float(comm[2]), null));
      cpx=float(comm[1]);
      cpy=float(comm[2]);
      break;
    case 'l'://relitive line to
      curNode.setNext(new Node('L', float(comm[1])+cpx, float(comm[2])+cpy, null));
      cpx=float(comm[1])+cpx;
      cpy=float(comm[2])+cpy;
      break;
    case 'H'://horizontal line
      curNode.setNext(new Node('L', float(comm[1]), cpy, null));
      cpx=float(comm[1]);
      break;
    case 'h'://relitive horizontal line
      curNode.setNext(new Node('L', float(comm[1])+cpx, cpy, null));
      cpx=float(comm[1])+cpx;
      break;
    case 'V'://vertical line
      curNode.setNext(new Node('L', cpx, float(comm[1]), null));
      cpy=float(comm[1]);
      break;
    case 'v'://relitive vertiacl line
      curNode.setNext(new Node('L', cpx, float(comm[1])+cpy, null));
      cpy=float(comm[1])+cpy;
      break;
    case 'C'://bezier curve
      curNode.setNext(new Node('C', float(comm[1]), float(comm[2]), float(comm[3]), float(comm[4]), float(comm[5]), float(comm[6]), null));
      cpx=float(comm[5]);
      cpy=float(comm[6]);
      cpx1=float(comm[3]);
      cpy1=float(comm[4]);
      break;
    case 'c'://relitive bezier curve
      curNode.setNext(new Node('C', float(comm[1])+cpx, float(comm[2])+cpy, float(comm[3])+cpx, float(comm[4])+cpy, float(comm[5])+cpx, float(comm[6])+cpy, null));
      cpx1=float(comm[3])+cpx;
      cpy1=float(comm[4])+cpy;
      cpx=float(comm[5])+cpx;
      cpy=float(comm[6])+cpy;
      break;
    case 'S'://shorthand curve
      curNode.setNext(new Node('C', cpx+(cpx-cpx1), cpy+(cpy-cpy1) ,float(comm[1]), float(comm[2]), float(comm[3]), float(comm[4]), null));
      cpx1=float(comm[1]);
      cpy1=float(comm[2]);
      cpx=float(comm[3]);
      cpy=float(comm[4]);
      break;
    case 's'://relitive shorthand curve
      curNode.setNext(new Node('C', cpx+(cpx-cpx1), cpy+(cpy-cpy1) ,float(comm[1])+cpx, float(comm[2])+cpy, float(comm[3])+cpx, float(comm[4])+cpy, null));
      cpx1=float(comm[1])+cpx;
      cpy1=float(comm[2])+cpx;
      cpx=float(comm[3])+cpx;
      cpy=float(comm[4])+cpy;
      break;
    case 'z'://close the path
      curNode.setNext(new Node('L', ipx, ipy, null));
      cpx=ipx;
      cpy=ipy;
      break;
    default:
      println("I don't know what to do with '"+comm[0].charAt(0)+"':");
      println(join(comm, '\t'));
      break;
    }//end of switch

    if(curNode.getNext()!=null)
      curNode=curNode.getNext();
  }//end of for

  g_shapeList.add(curHead);
  curHead=null;
  curNode=null;
}//end of method


