// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

class Button
{
  String txt;
  int x;
  int y;
  int w;
  int h;
  boolean highlight;
  boolean selected;
  boolean active;
  boolean useCrossHair;
  int state;
  
  Button(String _txt, int _x, int _y, int _w, int _h, boolean _useCrossHair)
  {
    txt = _txt;
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    highlight = false;
    selected = false;
    active = true;
    useCrossHair = _useCrossHair;
    state = 0;
  }

  void clear()
  {
    highlight = false;
  }
  
  boolean isMouseOver()
  {
    return highlight;
  }
  
  boolean isSelected()
  {
    return selected;
  }
  
  void setActive(boolean _active)
  {
    active = _active;
  }
  
  void setSelected(boolean _selected)
  {
    if (selected == _selected)
      return;
    selected = _selected;
    if (selected && useCrossHair)
      cursor(CROSS);
    else
      cursor(ARROW);
      
  }
  
  void draw()
  {
    if (active) {
      if (mouseX >= x && mouseX <= x+w && mouseY >= y && mouseY <= y+h)
        highlight = true;
      else
        highlight = false;
      stroke(#000000);
      noFill();
      rect(x, y, w, h, h/4);
      rect(x+2, y, w-1, h, h/4);
      rect(x, y+2, w, h-1, h/4);
      if (selected)
        fill(#BB0000);
      else if (highlight)
        fill(#00DD00);
      else
        fill(#00BB00);
      rect(x+2, y+2, w-4, h-4, h/4);
      fill(0);
      textAlign(CENTER,CENTER);
      text(txt, x+w/2, y+h/2);
    }
  }
}
