// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

void drawObjects()
{
    
//this draws the previous control line, if applicable//
if (false) {
  Node temp=curHead;
  while(temp!=null && temp.getNext()!=null)
    temp=temp.getNext();
  if(temp!=null && temp.getKind()=='C' && temp.x1!=-1){
    pushStyle();
    stroke(64);  
    line(temp.cx2, temp.cy2, temp.x1, temp.y1);
    popStyle();  
  }
}

  stroke(127);  
  //to draw the stored shapes
  noFill();
  for (int i=0; i<g_shapeList.size(); i++)
    drawShape((Node) g_shapeList.get(i));

  stroke(#000000);
  drawShape(curHead);


  ////Draw preview////
  if(mode.equals("draw") && curNode!=null)
    switch(shapeType){
    case 'L':
      //line(curNode.getX(), curNode.getY(), mouseX, mouseY);
      line(curNode.getX(), curNode.getY(), arm.wristX, arm.wristY);
      break;
    case 'E':
      //line(curNode.getX(), curNode.getY(), mouseX, mouseY);
      ellipseMode(CORNERS);
      ellipse(curNode.getX(), curNode.getY(),arm.wristX, arm.wristY);
      //ellipse(curNode.getX(), curNode.getY(), abs(arm.wristX-curNode.getX())*2, abs(arm.wristY-curNode.getY())*2);
      ellipseMode(CENTER);
      break;
    case 'C':
      if(curNode.x1!=-1){
        line(curNode.x1,curNode.y1,mouseX,mouseY);
      }
      break;
    }//end of switch

  if(mode.equals("traverse")){
    theTraverse.step();
  }//end if traversing
  else{
    arm.setTargetXY(mouseX, mouseY);
  }//end else

}

void connectSerial()
{
  int c;
  for (c = 0; c < Serial.list().length; c++)
  {
    launchPadPort = Serial.list()[c];
    if (launchPadPort.contains("cu.uart-") || isWindows())
    {
      println("Trying " + launchPadPort);
      try {
        //Serial port = new Serial(this, launchPadPort, 9600);
        Serial port = new Serial(this, launchPadPort, 9600);
        delay(1000);
        if (port.available() > 0)
        {
          launchPad = port;
          retrySerial = 0;
          return;
        }
        else
        {
          port.stop();
        }
      } catch(Exception e) {
      }
    }
  }
  retrySerial = 200;
}

void draw()
{
//println(frameRate);
  if (launchPad != null && launchPad.available() > 0) {
    //print("[");
    while (launchPad.available() > 0)
    {
      int b = launchPad.read();
      char bb = char(b);
      if (bb == '>')
      {
        print("SKETCH COMING:");
    while (launchPad.available() > 0)
    {
      b = launchPad.read();
      
      int tmpi = b-127;
      print(tmpi);
      print(" ");
    }
       
      }
      print("" + bb);
    }
    //print("]");
  }
    // Fill background with white (all colors are #RRGGBB hex values).  
    background(#FFFFFF);
    
    // Draw background, objects, boundaries, arms, buttons, status.
    drawBackground();
    if (mode.equals("*")) {
/* video
      for (int i=SBAR_LT; i < SBAR_KW; i++) {
        scrollBar[i].update(mouseX, mouseY);
        scrollBar[i].display();
      }
      for (int i=mainButtonCount; i < imageButtonCount; i++) {
        button[i].draw();
      }
      drawImage();
*/
    }
    else if (mode.equals("calibrate"))
    {
      drawCalibration();
    }
    else
    {
      drawBoard();
      drawObjects();
        arm.update();
      for (int i=0; i < mainButtonCount; i++) {
        button[i].draw();
      }

      drawStatus();
    
      // Draw codes being transmitted.
        noStroke();
        fill(70, 200);
        rect(width-2, height-22, -250, -37);
        textAlign(CENTER, CENTER);
        if (launchPad == null)
          fill(0, 200, 0);
        else {
          fill(50, 0, 0);
          text("Port: " + launchPadPort, width-126, height-50);
        }
      if (mode.equals("traverse"))// && g_port != null)
      {
        sendCommand();
        text(lastCommandSent, width-126, height-32);
      }
    }

  if (launchPad == null)
   {
     
    if (retrySerial == 0) {
           //print(".");
           retrySerial = 10000;
      thread("connectSerial");
    }
    else
    {
      --retrySerial;
      //delay(100);
      if (retrySerial == 100)
        println(retrySerial);
    }
  } 
  else
  {
/*      
    try
    {
       launchPad.write('A');
    } catch (Exception e)
    {
      launchPad = null;
      retrySerial = 200;
      //delay(10000);
      //connectSerial();
    }
*/      //delay(1000);
      // Read back from the port any info being sent.
  }
}

void drawStatus(){
  noStroke();
  fill(70,200);
  rect(0,height,width,-20);
  fill(0);
  textAlign(CENTER,CENTER);
  text(message,width/2,height-80);
  textAlign(LEFT,CENTER);
  text("X,Y(.5mm): " + str(int(arm.wristX-paperOffsetX)) + "," + str(int(arm.wristY-paperOffsetY)) + "  Shoulder:" + str(int(degrees(arm.shoulderAngle))) + "\u00B0 (" + str(arm.servo1) + "\u00B5s)" + "  Elbow:" + str(int(degrees(arm.elbowAngle))) + "\u00B0 (" + str(arm.servo2) + "\u00B5s)",6,height-10);
//  text("FPS="+str(round(frameRate)),70,height-10);

  textAlign(RIGHT,CENTER);
  String plural="s";
  if (g_shapeList.size()==1)
    plural="";
  text(str(g_shapeList.size())+" object"+plural,width-6,height-10);  
}


void drawBackground()
{
  if (logo != null)
        image(logo, 25, 10);
        //image(TERlogo, 312, 10);
  if (TERlogo != null)
        image(TERlogo, 512, 10);
}

void drawBoard()
{
        // Draw the clipboard, etc.
        scale(2);
        stroke(#000000);
        fill(#D3D1B5);
        rect(10, 40, 282, 206, 4);
        
        // Draw the drawing paper
        fill(#F8F8F8);
        //rect(20, 72, 217, 140); // Half sheet landscape
        //rect(20, 72, 140, 217); // Half sheet portrait
        //rect(20, 72, 217, 280); // Full sheet portrait
        rect(20, 72, 217, 178); // 8.5x7 inches
        stroke(#FFFF00);
        noFill();
        rect(40, 92, 177, 138); // Drawing area inside border

        // Draw the rest of the clipboard pieces
        stroke(#000000);
        fill(#C3C195);
        rect(10, 40, 10, 206, 4, 1, 1, 4);
        line(13, 72, 17, 72);
        rect(96, 43, 108, 34, 2);
        noFill();
        rect(96, 43, 108, 4, 2);
        rect(99, 49, 102, 0);
        rect(99, 51, 102, 0);
        fill(#CAC89C);
        noStroke();
        rect(99, 59, 103, 16, 2);
        
        // Draw the electronics
        fill(#DD0000);
        stroke(#000000);
        //rect(292-65, 40, 65, 50, 2);
        rect(292-65, 42, 63, 50, 2);
        line(arm.shoulderX, arm.shoulderY-20, arm.shoulderX, arm.shoulderY+20); 
        line(arm.shoulderX-20, arm.shoulderY, arm.shoulderX+20, arm.shoulderY);
        scale(.5);
}
