// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

void savePaths(){

  selectOutput("Select a file to write to:", "savePaths2");
}

void savePaths2(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
    setDefaultAction();
    return;
  }
  
  String[] toWrite=new String[g_shapeList.size()];
  for (int i=0; i<g_shapeList.size(); i++){
    Node temp=(Node)g_shapeList.get(i);
    String strToAdd="";
    while(temp!=null){
      switch (temp.getKind()){
      case 'L':
      case 'M':
        strToAdd=strToAdd+temp.getKind() + " " + temp.getX() + "," + temp.getY() + " ";
        break;
      case 'C':
        strToAdd=strToAdd+temp.getKind() + " " + temp.cx1 + "," + temp.cy1 + " " + temp.cx2 + "," + temp.cy2 + " " + temp.getX() + "," + temp.getY() + " ";
        break;
      }
      temp=temp.getNext();
    }//end of while
    toWrite[i]=strToAdd;
  }//end of for that puts strings in array

  saveStrings(selection.getAbsolutePath(),toWrite);
  setDefaultAction();


}//end of savePaths

void openPaths(){

  selectInput("Select a file to read:", "openPaths2");
}

void openPaths2(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
    setDefaultAction();
    return;
  }
  

  String myFile= selection.getAbsolutePath();

  if(myFile.substring(myFile.length()-4,myFile.length()).equals(".svg")){
    println("Ames Loves SVG!");
    parseSVG(myFile);
    setDefaultAction();
    return;
  }

  String[] pathsRead=loadStrings(myFile);


  g_shapeList=new ArrayList();

  for(int i=0; i<pathsRead.length; i++){
    String[] shapeStrs=splitTokens(pathsRead[i], " ,");
    if(shapeStrs.length<3 || shapeStrs[0].equals("")){
      println("Illegal file!");
      break;
    }//end of if illegal file

    curHead=new Node((shapeStrs[0]).charAt(0), float(shapeStrs[1]), float(shapeStrs[2]), null);
    curNode=curHead;
    for(int j=3; j<shapeStrs.length; j++){
      if(shapeStrs[j].equals(""))
        break;
      switch((shapeStrs[j]).charAt(0)){
      case 'M':
        if(shapeStrs.length+j<3){
          println("to few params");
          break;
        }
        curNode.setNext(new Node((shapeStrs[j]).charAt(0), float(shapeStrs[j+1]), float(shapeStrs[j+2]), null));
        curNode=curNode.getNext();
        j+=2;
        break;
      case 'L':
        if(shapeStrs.length+j<3){
          println("to few params for a Line");
          break;
        }
        curNode.setNext(new Node((shapeStrs[j]).charAt(0), float(shapeStrs[j+1]), float(shapeStrs[j+2]), null));
        curNode=curNode.getNext();
        j+=2;
        break;

      case 'C':
        if(shapeStrs.length+j<7){
          println("to few params for a Curve!");
          break;
        }
        curNode.setNext(new Node((shapeStrs[j]).charAt(0), float(shapeStrs[j+1]), float(shapeStrs[j+2]), float(shapeStrs[j+3]), float(shapeStrs[j+4]), float(shapeStrs[j+5]), float(shapeStrs[j+6]), null));
        curNode=curNode.getNext();
        j+=6;
        break;


      }
    }//end of for that adds rest of nodes
    g_shapeList.add(curHead);
    curHead=null;
    curNode=null;
  }//end of for that stores paths

  println("Opened "+g_shapeList.size()+" paths from: "+myFile);  
  setDefaultAction();

}//end of openPaths







