// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

/*
function drawEllipse(centerX, centerY, width, height) {
  
  context.beginPath();
  
  context.moveTo(centerX, centerY - height/2); // A1
  
  context.bezierCurveTo(
    centerX + width/2, centerY - height/2, // C1
    centerX + width/2, centerY + height/2, // C2
    centerX, centerY + height/2); // A2

  context.bezierCurveTo(
    centerX - width/2, centerY + height/2, // C3
    centerX - width/2, centerY - height/2, // C4
    centerX, centerY - height/2); // A1
 
  context.fillStyle = "red";
  context.fill();
  context.closePath();  
}


function ellipse(x, y, xDis, yDis) {
    var kappa = 0.5522848, // 4 * ((√(2) - 1) / 3)
        ox = xDis * kappa,  // control point offset horizontal
        oy = yDis * kappa,  // control point offset vertical
        xe = x + xDis,      // x-end
        ye = y + yDis;      // y-end

    this.moveTo(x - xDis, y);
    this.bezierCurveTo(x - xDis, y - oy, x - ox, y - yDis, x, y - yDis);
    this.bezierCurveTo(x + ox, y - yDis, xe, y - oy, xe, y);
    this.bezierCurveTo(xe, y + oy, x + ox, ye, x, ye);
    this.bezierCurveTo(x - ox, ye, x - xDis, y + oy, x - xDis, y);
        curNode.kind = 'C';
        curNode.x1 = 
        curNode.y1 = 
        curNode.cx1 = 
        curNode.cy1 = 
        curNode.cx2 = 
        curNode.cy2 = 
        curNode.setNext(new Node('C', arm.wristX, arm.wristY, -1, -1, -1, -1, null));
     }
*/

void keyPressed()
{
  switch(key) {
  case ESC:
    frameRate(30);
    key=0;
    setDefaultAction();
    break;
    
  case '/':
    frameRate(30);
    mode="standby";
/* video
    if (webcam != null)
    {
      webcam.stop();
      webcam = null;
    }
*/
    if(curHead != null) {
      if(curNode.x1 == -1) {
        curNode.x1=mouseX;
        curNode.y1=mouseY;
      }
      if(curNode.cx2==-1){
        curNode.cx2=mouseX;
        curNode.cy2=mouseY;
      }
      
      // Convert ellipse to two bezier curves.
      if (shapeType == 'E')
      {
        float kappa = 0.5522848; // 4 * ((√(2) - 1) / 3)
        float xDis = (arm.wristX - curNode.x1) / 2;
        float yDis = (arm.wristY - curNode.y1) / 2;
        float x = curNode.x1 + xDis;
        float y = curNode.y1 + yDis;
        float ox = xDis * kappa;  // control point offset horizontal
        float oy = yDis * kappa;  // control point offset vertical
        float xe = x + xDis;      // x-end
        float ye = y + yDis;      // y-end

        curNode.x1 = x - xDis;
        curNode.y1 = y;
        curNode.setNext(new Node('C', x - xDis, y - oy, x - ox, y - yDis, x, y - yDis, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', x + ox, y - yDis, xe, y - oy, xe, y, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', xe, y + oy, x + ox, ye, x, ye, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', x - ox, ye, x - xDis, y + oy, x - xDis, y, null));
        curNode = curNode.getNext();
      }
      g_shapeList.add(curHead);
      curNode=null;
      curHead=null;
    }
    message=(String)allMessages.get("standby");
    break;
  case 'q':
    println("Application closed");
    if (launchPad != null)
      launchPad.stop();
    exit();
  }//end of do regardless 

  if(mode.equals("standby")){
    switch(key){
    case 'd':
      mode="selectShape";
      message=(String)allMessages.get("selectShape");
      break;
    case 'o':
      openPaths();
      break;
    case 's':
      savePaths();
      break;
    case 't':
      frameRate(300);
  loadPulses();
    
      if(g_shapeList.size()>0){
        theTraverse=new Traverse();
        mode="traverse";
        message=(String)allMessages.get("traverse");
      }//end of if
      break;
    case 'c': // Calibrate
        mode="calibrate";
        //message = (String)allMessages.get("calibrate");
        calibrationState = 0;
        doNextCalibrationState();
        break;
    case '*': 
/* video
        mode="*";
        message=(String)allMessages.get("*");
        webcam = new Capture(this, 320, 240, 10);
        webcam.start();
*/

      break;
    case 'x':
      //mySerialDev.toggleSerial();
      break;
    case BACKSPACE:
      g_shapeList=new ArrayList();
      return;
    case 'l':
      arm.toggleLimits();
      break;
    }
  }//end if standby

  else if(mode.equals("selectShape")){
    switch(key){
    case 'l':
      mode="draw";
      message=(String)allMessages.get("drawL");
      shapeType='L';
      break;
    case 'e':
      mode="draw";
      message=(String)allMessages.get("drawE");
      shapeType='E';
      break;
    case 'f':
      mode="draw";
      message=(String)allMessages.get("drawF");
      shapeType='F';
      break;
    case 'c':
      mode="draw";
      message=(String)allMessages.get("drawC");
      shapeType='C';
      break;
    }
  }//end of if in selectShape

  else if(mode.equals("traverse")){
    switch(keyCode){
    case UP: 
      theTraverse.setSpeed(10);
      break;
    case DOWN:
      theTraverse.setSpeed(-10);
      break;
    }//end of switch
  }

  else if(mode.equals("calibrate")){
    switch(keyCode){
    case UP: 
      break;
    case DOWN:
      break;
    case LEFT: 
      break;
    case RIGHT:
      break;
    case ',': 
      break;
    case '.':
      break;
    }//end of switch
  }

  else if(mode.equals("draw")){
    switch(key){
    case 'n':
          if(curHead!=null){
      if(curNode.x1==-1){
        curNode.x1=mouseX;
        curNode.y1=mouseY;
      }
      if(curNode.cx2==-1){
        curNode.cx2=mouseX;
        curNode.cy2=mouseY;
      }
      // Convert ellipse to two bezier curves.
      if (shapeType == 'E')
      {
        float kappa = 0.5522848; // 4 * ((√(2) - 1) / 3)
        float xDis = (arm.wristX - curNode.x1) / 2;
        float yDis = (arm.wristY - curNode.y1) / 2;
        float x = curNode.x1 + xDis;
        float y = curNode.y1 + yDis;
        float ox = xDis * kappa;  // control point offset horizontal
        float oy = yDis * kappa;  // control point offset vertical
        float xe = x + xDis;      // x-end
        float ye = y + yDis;      // y-end

        curNode.x1 = x - xDis;
        curNode.y1 = y;
        curNode.setNext(new Node('C', x - xDis, y - oy, x - ox, y - yDis, x, y - yDis, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', x + ox, y - yDis, xe, y - oy, xe, y, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', xe, y + oy, x + ox, ye, x, ye, null));
        curNode = curNode.getNext();
        curNode.setNext(new Node('C', x - ox, ye, x - xDis, y + oy, x - xDis, y, null));
        curNode = curNode.getNext();
      }

      g_shapeList.add(curHead);
      curNode=null;
      curHead=null;
          }
      break;  
    }
  }
}



void setDefaultAction()
{
    key = '/';
    keyPressed();
    for (int i=0; i < buttonCount; i++) {
      button[i].setSelected(false);
      button[i].clear();
    }
}


void mousePressed()
{
  // Update the scrollbars if needed.
  for (int i=0; i < scrollBarCount; i++) {
    scrollBar[i].press();
  }
    
    
  // Check for any buttons pressed
  if (button[BUTTON_DRAW].isMouseOver()) {
    if (button[BUTTON_DRAW].isSelected()) {
      setDefaultAction();
      return;
    }
    setDefaultAction();
    button[BUTTON_DRAW].setSelected(true);
    key = 'd';
    keyPressed();
    key = 'f';
    keyPressed();
  }

  if (button[BUTTON_DRAWLINE].isMouseOver()) {
    if (button[BUTTON_DRAWLINE].isSelected()) {
      setDefaultAction();
      return;
    }
    setDefaultAction();
    button[BUTTON_DRAWLINE].setSelected(true);
    key = 'd';
    keyPressed();
    key = 'l';
    keyPressed();
    return;
  }

  if (button[BUTTON_DRAWCIRCLE].isMouseOver()) {
    if (button[BUTTON_DRAWCIRCLE].isSelected()) {
      setDefaultAction();
      return;
    }
    setDefaultAction();
    button[BUTTON_DRAWCIRCLE].setSelected(true);
    key = 'd';
    keyPressed();
    key = 'e';
    keyPressed();
    return;
  }

  if (button[BUTTON_DRAWCURVE].isMouseOver()) {
    if (button[BUTTON_DRAWCURVE].isSelected()) {
      setDefaultAction();
      return;
    }
    setDefaultAction();
    button[BUTTON_DRAWCURVE].setSelected(true);
    key = 'd';
    keyPressed();
    key = 'c';
    keyPressed();
    return;
  }

  if (button[BUTTON_UNDO].isMouseOver()) {
    setDefaultAction();
    button[BUTTON_UNDO].setSelected(true);
    if (g_shapeList.size() > 0)
      g_shapeList.remove(g_shapeList.size() - 1);
  }

  if (button[BUTTON_CLEAR].isMouseOver()) {
    setDefaultAction();
    button[BUTTON_CLEAR].setSelected(true);
    key = BACKSPACE;
    keyPressed();
    scrollBar[0].setPos(100);
  }

  if (button[BUTTON_OPEN].isMouseOver()) {
    setDefaultAction();
    button[BUTTON_OPEN].setSelected(true);
    key = 'o';
    keyPressed();
  }

  if (button[BUTTON_SAVE].isMouseOver()) {
    setDefaultAction();
    button[BUTTON_SAVE].setSelected(true);
    key = 's';
    keyPressed();
  }

  if (button[BUTTON_STOP].isMouseOver() || button[BUTTON_CANCEL].isMouseOver()) {
    curHead = curNode = null;
    setDefaultAction();
    button[BUTTON_STOP].setSelected(true);
    key = '/';
    keyPressed();
  }

  if (button[BUTTON_IMPORT].isMouseOver()) {
    curHead = curNode = null;
    setDefaultAction();
    button[BUTTON_STOP].setSelected(true);
    key = '/';
    keyPressed();
/* video    
    raster2vector();
*/
  }

//  if (button[BUTTON_CANCEL].isMouseOver()) {
//    key = '/';
//    keyPressed();
//  }

  if (button[BUTTON_DEFAULTS].isMouseOver()) {
    scrollBar[SBAR_LT].setPos(DEFAULT_LOWTHRESHOLD);
    scrollBar[SBAR_HT].setPos(DEFAULT_HIGHTHRESHOLD);
    scrollBar[SBAR_KR].setPos(DEFAULT_GAUSSIANKERNELRADIUS);
    scrollBar[SBAR_KW].setPos(DEFAULT_GAUSSIANKERNELWIDTH);
  }

  if (button[BUTTON_CALIBRATE].isMouseOver()) {
    setDefaultAction();
    key = 'c';
    keyPressed();
    return;
  }
  if (button[BUTTON_CALIBRATECANCEL].isMouseOver()) {
    curHead = curNode = null;
    setDefaultAction();
    button[BUTTON_STOP].setSelected(true);
    key = '/';
    keyPressed();
  }
  
  if (button[BUTTON_CALIBRATENEXT].isMouseOver()) {
    doNextCalibrationState();
  }

  if (button[BUTTON_SEND].isMouseOver()) {
    curHead = curNode = null;
    setDefaultAction();
    button[BUTTON_SEND].setSelected(true);
    key = 't';
    keyPressed();
  }

  if (button[BUTTON_HELP].isMouseOver()) {
    setDefaultAction();
    //button[BUTTON_HELP].setSelected(true);
    link("file://" + g_path + "picassobot_help.html");
  }

  if (curHead==null && mode.equals("draw")){
    curNode=new Node('M', arm.wristX, arm.wristY, null);
    curHead=curNode;
  }//end of is ready to draw
  else if(mode.equals("draw")){
    switch(shapeType){
    case 'L':
      curNode.setNext(new Node('L', arm.wristX, arm.wristY, null));
      setDefaultAction();
      button[BUTTON_DRAWLINE].setSelected(true);
      key = 'd';
      keyPressed();
      key = 'l';
      keyPressed();
      return;
      //break;
    case 'E':
      curNode.setNext(new Node('E', arm.wristX, arm.wristY, null));
      setDefaultAction();
      button[BUTTON_DRAWCIRCLE].setSelected(true);
      key = 'd';
      keyPressed();
      key = 'e';
      keyPressed();
      return;
      //break;
    case 'C':
      if (curNode.x1!=-1) { //ready for a new node w/ new control point 1
        curNode.setNext(new Node('C', arm.wristX, arm.wristY, -1, -1, -1, -1, null));
      }
      else if (curNode.cx2==-1){ //ready to add control point 2
        curNode.cx2=mouseX;
        curNode.cy2=mouseY;
      }//end of else if
      else{//finally ready to put in the ending point!
         curNode.x1=arm.wristX;
         curNode.y1=arm.wristY;
        setDefaultAction();
        button[BUTTON_DRAWCURVE].setSelected(true);
        key = 'd';
        keyPressed();
        key = 'c';
        keyPressed();
        return;
      }
      break;
    }//end of switch
    if(curNode.getNext()!=null)
      curNode=curNode.getNext();
  }//end of drawing

}//end of mousePressed

void mouseDragged()
{
  if(mode.equals("draw") && shapeType=='F'&& (dist(curNode.getX(), curNode.getY(), arm.wristX, arm.wristY)>4)){
    curNode.setNext(new Node('L', arm.wristX, arm.wristY, null));
    curNode=curNode.getNext();
    println("wrist XY(" + arm.wristX + "," + arm.wristY);
  }
  
  //redraw();
}

void mouseMoved() {
  //redraw();
}

void mouseReleased()
{
    for (int i=0; i < scrollBarCount; i++) {
      scrollBar[i].release();
    }
  
  button[BUTTON_UNDO].setSelected(false);
  button[BUTTON_CLEAR].setSelected(false);
  button[BUTTON_STOP].setSelected(false);
  
  if(mode.equals("draw") && shapeType=='F' && curNode!=null){
    if(curNode.getKind()!='M')
      g_shapeList.add(curHead);
    curNode=null;
    curHead=null;
  }//end of if drawing a free line
/*
// This is for having the line turn off when mouse released.
  if(mode.equals("draw") && shapeType=='L' && curNode!=null){
      curNode.setNext(new Node('L', arm.wristX, arm.wristY, null));
      setDefaultAction();
      button[BUTTON_DRAWLINE].setSelected(true);
      key = 'd';
      keyPressed();
      key = 'l';
      keyPressed();
 }//end of if drawing a line
*/
}
