// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

void sendCommand()
{
      String servo1 = "0000" + str(arm.servo1);
      String servo2 = "0000" + str(arm.servo2);
      String servo3;
      if (arm.wristDown)
        servo3 = "0000" + str(g_servoPulses[4]);//"0600";
      else
        servo3 = "0000" + str(g_servoPulses[5]);//"2300";
      lastCommandSent = "W" + servo3.substring(servo3.length() - 4) + "E" + servo2.substring(servo2.length() - 4) + "S" + servo1.substring(servo1.length() - 4) + "\r";
    try
    {
      launchPad.write(lastCommandSent);
      delay(100);
    } catch (Exception e)
    {
      launchPad = null;
      retrySerial = 200;
      //delay(10000);
      //connectSerial();
    }
}
//import processing.serial.*;


class SerialDev {

  int a1Chan=5;
  int a2Chan=6;

  boolean send=false;
  boolean penDown=false;

  /////serial stuff/////
  Serial myPort;    // The serial device   
  String cmd="";    //the command to send
  String device="none"; //the device to use


  void openSerial() {
    device=Serial.list()[0];
    println(device + " IS NOW ON!!!!");
//    myPort = new Serial(thisApplet, device, 115200); //setup device (using first device on list, which should be the serial adapter)
//    send=true;
  }

  void closeSerial() {
    if (!(device.equals("none"))) {
      myPort.stop();
      device="none"; 
      send=false;
    }
  }


  void toggleSerial() {
    if (send)
      closeSerial();
    else
      openSerial();
  }

  void sendSerial(float a1, float a2) {
    if (penDown)
      cmd="W1";
    else
      cmd="W0";

    cmd+="#"+str(a1Chan)+"P"+str(int(map(degrees(a1), 0, -90, 2126, 1273)));
    cmd+="#"+str(a2Chan)+"P"+str(int(map(degrees(a2), 0, 90, 2428, 1538)));
    cmd+="T"+str(int(1000/frameRate));
    cmd+="\r";

    if (send)
      myPort.write(cmd); //write data

  //cmd = "S1=" + degrees(a1) + " S2=" + degrees(a2) + " S3=" + (penDown ? "Down" : "Up");
}//end send (angles)

  void setPen(boolean newPenDown) {
    penDown=newPenDown;
  }//end of setPen
  
  void drawInfo()
  {

    noStroke();
    fill(70, 200);
    rect(width-2, height-22, -200, -37);
    if (send)
      fill(0, 200, 0);
    else
      fill(50, 0, 0);
    textAlign(CENTER, CENTER);
    text("CMD: " + cmd, width-102, height-32);
    text(device, width-102, height-50);
  }//end of drawInfo
}//end class

