// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

//float drawSpeed=60; //in pixels/second
float drawSpeed=90; //in pixels/second
  PrintWriter output = null;
  

class Traverse{
  final float startX = paperOffsetX + startOffsetX;
  final float startY = paperOffsetY + startOffsetY;
  final float moveSpeedDiff = 1;
  
  float t=0; //between 0 and 1
  float x0=0;
  float y0=0;
  float x1=0;
  float y1=0;
  float curX=0;//only used by curves
  float curY=0;
  float newX=0;//only used by curves
  float newY=0;



  float deltaT=0;

  int index=0;

  char kind=' ';
  boolean ending; 

  Traverse(){
    
    output = createWriter("traverse.txt");
    curHead=null;
    x1 = startX;
    y1 = startY;
//    x1 = 10;
//    y1 = 300;
    ending=false;
    //setSpeed(20);
    //setSpeed(60);
  }

  void step(){
    float stepSize=drawSpeed/frameRate;
    
    if (curHead==null && !ending){
      curHead=(Node) g_shapeList.get(index);
      curNode=curHead;
    }//end get new head

      if (kind==' '){
      x0=x1;
      y0=y1;
      kind=curNode.getKind();
      x1=curNode.getX();
      y1=curNode.getY();

      deltaT= stepSize/dist(x0,y0,x1,y1);
      t=0;

      if(kind=='M'){
        arm.setWristDown(false);
      }
      else{
        arm.setWristDown(true);
      }
    }//end if new node


      switch(kind){
    case 'L':
      t+=stepSize/dist(x0,y0,x1,y1);
      arm.setTargetXY(x0+t*(x1-x0),y0+t*(y1-y0));
      break;
    case 'E':
      t+=stepSize/dist(x0,y0,x1,y1);
      arm.setTargetXY(x0+t*(x1-x0),y0+t*(y1-y0));
      break;
    case 'M':
      t+=(stepSize*moveSpeedDiff)/dist(x0,y0,x1,y1);
      arm.setTargetXY(x0+t*(x1-x0),y0+t*(y1-y0));
      break;
    case 'C':
      while(dist(curX,curY,newX,newY)<stepSize){
        t+=.0001;
        newX= pow((1-t), 3)*x0 + 3*t*pow((1-t), 2)*curNode.cx1 + 3*t*t*(1-t)*curNode.cx2 + pow(t, 3)*x1;
        newY= pow((1-t), 3)*y0 + 3*t*pow((1-t), 2)*curNode.cy1 + 3*t*t*(1-t)*curNode.cy2 + pow(t, 3)*y1;
      }
      curX=newX;
      curY=newY;
      arm.setTargetXY(curX, curY);
      break;
    }//end switch

    if(t>=1){
      kind=' '; 
      if(curNode!=null){
        curNode=curNode.getNext();
      }//end of next node exists
      if(ending){
        //mode="standby";
        //message=(String)allMessages.get("standby");
        if (output != null)
         output.close();   
        setDefaultAction();     
      }
    }//end of ran out of stuff to travel on the current node

    if(kind==' ' && curNode==null){
      curHead=null;
      curNode=null;
      index++;
      if (index>=g_shapeList.size()){
        x0=x1;
        y0=y1;
        kind='M';
        println("here "+index + " shapeListSize " + g_shapeList.size());
        x1 = startX;
        y1 = startY;
        deltaT= stepSize/dist(x0,y0,x1,y1);
        t=0;
        ending=true;
        arm.setWristDown(false);
      }//end of if
    }
  }//end step

void setSpeed(float increment){
    drawSpeed+=increment;
    if(drawSpeed<0)
      drawSpeed=0;

    //message="drawSpeed=" + theTraverse.drawSpeed+" pix/sec";
  }//end setSpeed

}






